package com.simuwang.base.pojo.dto.report;

import com.simuwang.base.pojo.dos.report.ReportFinancialIndicatorsDO;
import lombok.Getter;
import lombok.Setter;

@Setter
@Getter
public class ReportFinancialIndicatorsDTO extends BaseReportLevelDTO<ReportFinancialIndicatorsDO> {
    /**
     * 年度
     */
    private Integer yearly;
    /**
     * 期末基金净资产
     */
    private String assetNet;
    /**
     * 报告期期末单位净值
     */
    private String nav;
    /**
     * 本期利润
     */
    private String profit;
    /**
     * 本期已实现收益
     */
    private String realizedIncome;
    /**
     * 期末可供分配利润
     */
    private String undistributedProfit;

    public ReportFinancialIndicatorsDTO() {
        super();
    }

    public ReportFinancialIndicatorsDTO(Integer fileId) {
        super(fileId);
    }

    public ReportFinancialIndicatorsDTO(Integer fileId, String level) {
        super(fileId, level);
    }

    @Override
    public ReportFinancialIndicatorsDO toEntity() {
        ReportFinancialIndicatorsDO entity = new ReportFinancialIndicatorsDO();
        entity.setFileId(this.getFileId());
        entity.setLevel(this.getLevel());
        entity.setEndDate(this.yearly);
        entity.setFundAssetSize(this.toBigDecimal(this.assetNet));
        entity.setNav(this.toBigDecimal(this.nav));
        entity.setProfit(this.toBigDecimal(this.profit));
        entity.setRealizedIncome(this.toBigDecimal(this.realizedIncome));
        entity.setUndistributedProfit(this.toBigDecimal(this.undistributedProfit));
        return entity;
    }

    @Override
    public String toString() {
        return "{" +
                super.toString() +
                ", yearly=" + yearly +
                ", assetNet=" + assetNet +
                ", nav=" + nav +
                ", profit=" + profit +
                ", undistributedProfit=" + undistributedProfit +
                ", realizedIncome=" + realizedIncome +
                '}';
    }
}
